/*
 * I2C_Software .c
 *
 *  Created on: Oct 20, 2023
 *      Author: JM_Palomino
 */
/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "COPFree.h"
#include "PTB.h"
#include "I2C_Software.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

void delay_i2c(void )//4.386 us when cpu clk speed = 8MHz.
 {  
  asm { 
 	 CLR $82
 	 MOV #$1, $82
     b: 
       NOP
       DBNZ $82, b
   }
 }	
void SCL_HIGH(void) { 
	SCL = 0;
}
void SDA_HIGH(void) { 
	SDA = 0;
}
void SDA_LOW(void) { 
	SDA = 1;
	SDA_IN=0;
}
void SCL_LOW(void) { 
	SCL = 1;
	SCL_IN=0;
}
void i2c_Start(void) {
    SDA_HIGH();
    SCL_HIGH();
    delay_i2c(); 
    SDA_LOW();
    SCL_LOW();
}

void i2c_Stop(void) {
    SDA_LOW();
    SCL_HIGH();
    delay_i2c(); 
    SDA_HIGH();
}

void i2c_Write(unsigned int data) {
    char bit_temp;

    SCL_LOW();

    for (bit_temp = 0; bit_temp < 8; bit_temp++) {

        if (data & 0x80)
            SDA_HIGH();
        else
            SDA_LOW();

        SCL_HIGH();
        data <<= 1;
        SCL_LOW();
    }
    delay_i2c();  
    SCL_HIGH();
    SDA_HIGH();

    bit_temp = SDA_IN; // possible ACK bit
    delay_i2c(); 
    SCL_LOW();
    SDA_LOW();

//    return bit_temp;
}

unsigned int i2c_Read(char NACK) {
    char bit_temp;
    unsigned char data;

    SDA_HIGH();

    for (bit_temp = 0; bit_temp < 8; bit_temp++) {
        data <<= 1;

        SCL_HIGH();

        if (SDA_IN)
            data |= 1;
        delay_i2c();  
        SCL_LOW();
    }

    if (NACK == 1)
        SDA_LOW();
    else
        SDA_HIGH();

    SCL_HIGH();
    delay_i2c(); 
    SCL_LOW();
    SDA_LOW();

    return data;
}

