/* ###################################################################
**     Filename    : main.c
**     Project     : example_2
**     Processor   : MC9S08SE8CWL
**     Version     : Driver 01.12
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2023-10-19, 18:24, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/*!
** @file main.c
** @version 01.12
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup main_module main module documentation
**  @{
*/         
/* MODULE main */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "COPFree.h"
#include "PTB.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* User includes (#include below this line is not maintained by Processor Expert) */
#include "I2C_Software.h"

#define DAC_address 0b11000000 //This is the address when the pin A0 of the dac is connected a GND.
#define DAC_write 0x40 //Command to writing a value in the dac.
#define DAC_write_e2p 0b011 //Command writing a value in the internal eeprom of the dac.

short int i=0;

const sine[100] =
{
  2048, 2176, 2304, 2431, 2557, 2680, 2801, 2919,
 3034, 3145, 3251, 3353, 3449, 3540, 3625, 3704,
 3776, 3842, 3900, 3951, 3995, 4031, 4059, 4079,
 4091, 4095, 4091, 4079, 4059, 4031, 3995, 3951,
 3900, 3842, 3776, 3704, 3625, 3540, 3449, 3353,
 3251, 3145, 3034, 2919, 2801, 2680, 2557, 2431,
 2304, 2176, 2048, 1919, 1791, 1664, 1538, 1415,
 1294, 1176, 1061,  950,  844,  742,  646,  555,
  470,  391,  319,  253,  195,  144,  100,   64,
   36,   16,    4,    0,    4,   16,   36,   64,
  100,  144,  195,  253,  319,  391,  470,  555,
  646,  742,  844,  950, 1061, 1176, 1294, 1415,
 1538, 1664, 1791, 1919
};	

void mcp4725_Write(unsigned int vout) {
	
unsigned int  dato[5];
uint8_t f=0;

dato[0] =  DAC_address;
dato[1] =  DAC_write;
dato[2] = (vout / 16); // Upper data bits     (D11.D10.D9.D8.D7.D6.D5.D4)
dato[3] = (vout % 16) << 4;  // Lower data bits     (D3.D2.D1.D0.x.x.x.x)

i2c_Start();
for(f=0; f<4; f++) {
  i2c_Write(dato[f]);
  }
i2c_Stop();

}

void main(void)
{
  /* Write your local variable definition here */
   
  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  /* Write your code here */
  COPFree_Init();
  PTB_Init();
  PTBD = 0;  
  
  for(;;) {
	  for(i = 0; i < 100; i++){
	      mcp4725_Write(sine[i]);
	      asm nop;
	     }
  }
  
  /* For example: for(;;) { } */

  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END main */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
